#include <kcmdlineargs.h>
#include <kaboutdata.h>
#include <kmessagebox.h>
#include <klocale.h>
#include <kconfig.h>
#include <kapp.h>
#include <iostream>
#include <stdio.h>

#include "kquick.h"
#include "qtrans.h"
#include "utils.h"
//#include "quick.h"
#include "outputc.h"

static const char *description = I18N_NOOP ("QTrans - Instant translator for KDE based on Babylon");

static KCmdLineOptions options[] =
{
  {0, 0, 0}
};

extern bool logQueries;
extern bool AutoOnTop;

#define NOTFOUND i18n("Nothing found! Please try to mark the word exactly.\n")

unsigned char cgiHexValue[256] =
{
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1,
  2, 3, 4, 5, 6, 7, 8, 9, 0, 0, 0, 0, 0, 0, 0, 10, 11, 12, 13, 14, 15, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  10, 11, 12, 13, 14, 15, 0, 0, 0
};

char *cgiUnescape (char *cp, int len)
{
  char *s;
  int escapedValue = 0;
  int srcPos = 0;
  int dstPos = 0;
  s = new char[len + 1];
  int escapeState = 0;

  if (!s) return NULL;

  while (srcPos < len)
  {
    int ch = cp[srcPos];
    switch (escapeState)
    {
      case 0:
        if (ch == '%')
        {
          escapeState = 1;
        }
        else if (ch == '+')
        {
          s[dstPos++] = ' ';
        }
        else
        {
          s[dstPos++] = ch;
        }
      break;
      case 1:
        escapedValue = cgiHexValue[ch] << 4;
        escapeState = 2;
      break;
      case 2:
        escapedValue += cgiHexValue[ch];
        s[dstPos++] = escapedValue;
        escapeState = 0;
      break;
    }
    srcPos++;
  }
  s[dstPos] = '\0';
  return s;
}

int main (int argc, char *argv[])
{
  char *query;
  if ((query = getenv ("QUERY_STRING")) != NULL)
    {
      //CGI VERSION
      query = cgiUnescape (query, strlen (query));
      if (strstr (query, "q=")) query += 2;

      printf ("Content-type: text/html; charset=UTF-8\r\n\r\n");
      printf ("<html>\n<head>\n");
      printf ("<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n");
      printf ("<TITLE>*Quick</TITLE>\n</head>\n<body bgcolor=\"#fbf8f1\"><font face=\"helvetica,arial\">");
#ifdef CUSTOMIZED
      printf ("<a href=\"http://futurezone.orf.at/\"><img src=\"http://www.futureware.at/bilder/fuzo.gif\" alt=\"FutureZone\" width=75 height=31 border=0></a>\n");
#else
      printf ("<a href=\"http://www.futureware.at/quick.htm\"><img src=\"http://www.futureware.at/bilder/logoquick.png\" alt=\"*Quick Logo\" width=260 height=100 border=0></a>\n");
#endif
      printf ("<form action=\"quick\" method=\"get\">\n");
      printf ("Suche: <input size=40 maxlength=40 name=\"q\" value=\"%s\">\n", query);
      printf ("</form><P>\n");
#if 0
      if (strlen (getenv ("HTTP_REFERER")))
      {
        printf ("<form action=\"page\" method=\"get\">\n");
        printf ("&Uuml;berarbeite Seite: <input size=30 maxlength=100 name=\"q\" value=\"%s\">\n", getenv ("HTTP_REFERER"));
        printf ("</form><P>\n");
      }
#endif
      if (strlen (query))
      {
        Quick quick;
        OutputC * output;
        output = new OutputC ();
        if (!quick.search (query, output, 0)) printf (NOTFOUND);
        output->write ("</font></body></html>\n");
      }
      else
      {
        printf ("Bitte den Suchtext als Parameter angeben.\n<p>");
#ifndef CUSTOMIZED
        printf ("Netscape <a href = \"javascript:myurl=&quot;http://quick.futureware.at/cgi-bin/quick?&quot;;window.open(myurl.concat(document.getSelection()),&quot;test&quot;);\">Browser Integration < /a >:\n ");
        printf ("Dr&uuml;cken Sie &uuml;ber Browser Integration die rechte Maustaste, und dann & quot; Hinzuf & uuml; gen zu den Lesezeichen (Bookmarks) & quot; Nun k&ouml;nnen Sie einfach ein Wort markieren, und dann durch das Lesezeichen nach diesem Wort suchen.\n");
#endif
      }
    }
    else
    {
      //Non-Web Version
      if (argc > 1 && strcmp (argv[1], "-caption") && strcmp (argv[1], "-display"))
      {
        //Console Version
        //There are still command line parameters, lets parse them!
        Quick quick;
        OutputC * output;
        output = new OutputC ();
        if (!quick.search (argv[1], output, 1)) printf (NOTFOUND);
      }
      else
      {
        //KDE Version
        QString n = NAME, c = VERSION;
        cout << n << "  v. " << c << "\n";
        KAboutData aboutData ("kquick", I18N_NOOP ("KQuick"),VERSION, description,KAboutData::License_GPL,
		    "(c) 2001, Futureware 2001", 0,"http://www.futureware.at/quick.htm","quick@futureware.at");
        aboutData.addAuthor("Philipp Ghring", 0,"pg@futureware.at");
        aboutData.addCredit("Olaf3-Matteo Merli", I18N_NOOP("QTrans User Interface"),"merlim@libero.it");
        aboutData.addCredit("Frederic Jolliton",I18N_NOOP ("Babylon library"),"fjolliton@free.fr");
        aboutData.addCredit("Gonzalo Payo Navarro",I18N_NOOP ("Spanish Translation"),"gpayo@conceptoe.com");
        KCmdLineArgs::init (argc, argv, &aboutData);
        KCmdLineArgs::addCmdLineOptions (options);
        KApplication app (argc, argv, "kquick");

        app.config()->setGroup (0);
        if (!app.config()->hasKey ("LogQueries"))
        {
          KMessageBox Frage;
          app.config()->writeEntry ("LogQueries", Frage.questionYesNo (0, i18n ("Shall all queries be logged and sent back to the developers? \n(You can change this setting in the options menu.)"), i18n ("kquick"),0,i18n("Yes"),i18n("No"))==1);
        }
        logQueries = app.config()->readBoolEntry("LogQueries");
        if (!app.config()->hasKey("AutoOnTop")) app.config()->writeEntry("AutoOnTop",true);
        AutoOnTop =  app.config()->readBoolEntry("AutoOnTop");

        KQuick *kquick =  new KQuick(0,0);
        kquick->setCaption(n + " - v. " + c);
        app.setMainWidget(kquick);

/*        if (kquicks->DockIcon) kquick->Dock->show();
        // Is a bug fix, not elegant but works!
        if (kquick->StartMin)
        {
          kquick->show();
          kquick->showMinimized();
          kquick->hide();
        }
        else
*/
          kquick->show();

        return app.exec ();
    }
  }
  return 0;
}
