
#ifndef QTRANS_H
#define QTRANS_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <kapp.h>
#include <kglobalaccel.h>
#include <qwidget.h>
#include <qtextbrowser.h>
#include <qlineedit.h>
#include <qclipboard.h>
#include <qpushbutton.h>
#include <qevent.h>
#include <string>

#include "systemtray.h"

/** QTrans is the base class of the porject */
class QTrans : public QWidget
{
  Q_OBJECT 
  public:
    /** construtor */
    QTrans(QWidget* parent=0, const char *name=0);
    /** destructor */
    ~QTrans();
protected:
        QTextBrowser *Out;
	QLineEdit *In;
        QPushButton *bExit;
	QPushButton *bTranslate;
        QPushButton *bAbout;
        QPushButton *bConf;

        void updateMask();
        //virtual void mouseMoveEvent(QMouseEvent *);
        void closeEvent(QCloseEvent *);
        /*QMouseEvent*Mouse;*/

public slots:
    virtual void slot_Quit();
    virtual void slot_Ok();
    virtual void slot_About();
    virtual void slot_ClipChanged();
    virtual void slot_Config();
    virtual void slot_ShortCut();
public:
  void Translate(QString);
  SystemTray *Dock;
  void Clear_Out();
  int Configure(QString);
  QClipboard *clip;
  KGlobalAccel *ShortCut ;

  string Lang_Path;
  string English_Path;
  /*-- Boolean Controls --*/
  bool AutoPopUp,
       DontClose,
       DockIcon,
       StartMin,
       enableShortCut;
  /*Personal ShortCut*/
  QString ShortKey;
};

#endif
